import { AbstractProperty } from "../../properties/abstract-property";
import { PropertyTemplate } from "../../properties/factory/property-template";
import { GroupedProperties, GroupOfProperties } from "../../properties/group-of-properties";
import { ListIndex } from "../../properties/factory/list-index";
import { GroupOfPropertiesImpl } from "../../properties/group-of-properties-impl";
import { SiblingAccess } from "../../provider/list-provider/sibling-access";
import { ValidationResult } from "../../validators/validation-result";
export declare class GroupOfPropertiesBuilder {
    private readonly propertyGroup;
    constructor(propertyGroup: <D>(id: string, properties: GroupedProperties<D>, exportFcn: (props: GroupedProperties<D>) => D | null, importFcn: (props: GroupedProperties<D>, data: D | null) => void) => GroupOfPropertiesImpl<GroupedProperties<D>, D>);
    template<D>(propertiesOfGroup: (idFcn: (id: string) => string, index?: ListIndex, siblingAccess?: SiblingAccess<GroupOfProperties<GroupedProperties<D>, D>>) => GroupedProperties<D>): PropertyTemplate<GroupOfProperties<GroupedProperties<D>, D>, D>;
    of<D>(id: string, propertiesOfGroup: GroupedProperties<D>): GroupOfProperties<GroupedProperties<D>, D>;
    bindValidator<T extends {
        [id: string]: AbstractProperty;
    }, D>(group: GroupOfProperties<T, D>, validator: (group: T) => ValidationResult | Promise<ValidationResult>): void;
}
