"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GroupOfPropertiesBuilder = void 0;
const defaultExportFcn = (props) => Object.keys(props).reduce((res, cur) => {
    res[cur] = props[cur].exportData();
    return res;
}, {});
const defaultImportFcn = (props, data) => data instanceof Object && Object.keys(props).forEach(key => {
    props[key].importData(data[key]);
});
class GroupOfPropertiesBuilder {
    constructor(propertyGroup) {
        this.propertyGroup = propertyGroup;
    }
    template(propertiesOfGroup) {
        return (id, index, siblingAccess) => this.propertyGroup(id, propertiesOfGroup(suffix => `${id}_${suffix}`, index, siblingAccess), defaultExportFcn, defaultImportFcn);
    }
    of(id, propertiesOfGroup) {
        return this.propertyGroup(id, propertiesOfGroup, defaultExportFcn, defaultImportFcn);
    }
    bindValidator(group, validator) {
        const instance = {
            getValidatedProperties: () => group.propertiesAsList,
            validate: () => validator(group.properties)
        };
        group.addValidator(instance);
    }
}
exports.GroupOfPropertiesBuilder = GroupOfPropertiesBuilder;
