"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListOfPropertiesBuilder = exports.SelectionMode = void 0;
const simple_list_provider_1 = require("../../provider/list-provider/simple-list-provider");
var SelectionMode;
(function (SelectionMode) {
    SelectionMode[SelectionMode["MultiSelect"] = 0] = "MultiSelect";
    SelectionMode[SelectionMode["SingleSelect"] = 1] = "SingleSelect";
})(SelectionMode = exports.SelectionMode || (exports.SelectionMode = {}));
class ListOfPropertiesBuilder {
    constructor(propertyList) {
        this.propertyList = propertyList;
    }
    create(id, itemTemplate, selectionMode) {
        const selectedIndices = [];
        const listProvider = new simple_list_provider_1.SimpleListProvider(id, itemTemplate, (idx) => selectedIndices.includes(idx));
        return this.propertyList(id, listProvider, selectedIndices, selectionMode === SelectionMode.MultiSelect);
    }
    template(id, factory) {
        return (prefix, index, siblingAccess) => factory(this, `${prefix}_${id}`, index, siblingAccess);
    }
    bindValidator(list, validator) {
        const instance = {
            getValidatedProperties: () => list.list,
            validate: validator
        };
        list.addValidator(instance);
    }
}
exports.ListOfPropertiesBuilder = ListOfPropertiesBuilder;
