import { AbstractProperty } from "../properties/abstract-property";
import { RuleEngineUpdateHandler } from "./rule-engine-update-handler-impl";
import { Snapshot } from "./snapshot/snapshot";
import { BuilderOptions } from "./builder/builder-options";
import { Builder } from "./builder/builder";
import { ValidationResult } from "../validators/validation-result";
import { ValidatorInstance } from "./validation/validator-instance-impl";
import { AbstractDataProperty } from "../properties/abstract-data-property";
export declare class RuleEngine implements RuleEngineUpdateHandler {
    private readonly propertyMap;
    private readonly dependencyGraph;
    private readonly validations;
    private readonly dataLinks;
    private readonly snapshots;
    private propertiesThatRequireAnEagerUpdate;
    private get properties();
    builder(options: BuilderOptions): Builder;
    takeSnapShot(key?: string): Snapshot;
    restoreSnapShot(key?: string): void;
    linkPropertyData<D>(propertyA: AbstractDataProperty<D>, propertyB: AbstractDataProperty<D>): void;
    unlinkPropertyData<D>(propertyA: AbstractDataProperty<D>, propertyB: AbstractDataProperty<D>): void;
    private createDataLinkKey;
    transferData<D>(fromProperty: AbstractDataProperty<D>, toProperty: AbstractDataProperty<D>): void;
    needsAnUpdate(mightHaveChanged: AbstractProperty): void;
    updateValue(property: AbstractProperty): Promise<void>;
    private hasBeenUpdated;
    invalidateValidationResults(validators: readonly ValidatorInstance<readonly AbstractProperty[]>[]): void;
    validate(validators: readonly ValidatorInstance<readonly AbstractProperty[]>[]): Promise<ValidationResult>[];
    private getValidationProcess;
}
