"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.upgradeAsPropertyWithChoices = void 0;
exports.upgradeAsPropertyWithChoices = (propertyScalar, choicesSource) => {
    const upgradedProperty = propertyScalar;
    if (choicesSource instanceof Function) {
        upgradedProperty.getChoices = choicesSource;
        upgradedProperty.awaitChoices = () => Promise.resolve(choicesSource());
    }
    else {
        upgradedProperty.getChoices = () => choicesSource.getNonNullValue();
        upgradedProperty.awaitChoices = () => choicesSource.awaitValue().then(res => res !== null && res !== void 0 ? res : []);
        upgradedProperty.isProcessing = () => choicesSource.isProcessing();
    }
    return upgradedProperty;
};
