"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Trigger = void 0;
const logger_1 = require("../util/logger/logger");
class Trigger {
    constructor(label) {
        this.label = label;
        this.listeners = [];
    }
    trigger() {
        return Promise.all(this.listeners.map(listener => listener.onTriggered())).then(() => {
            return;
        });
    }
    registerTriggerListener(listener) {
        if (!this.listeners.find(l => l === listener)) {
            this.listeners.push(listener);
        }
        else {
            logger_1.Logger.debug('Tigger.registerTriggerListener: listener already registered');
        }
    }
    deregisterTriggerListener(listener) {
        const idx = this.listeners.findIndex(l => l === listener);
        if (idx >= 0) {
            this.listeners.splice(idx, 1);
        }
        else {
            logger_1.Logger.debug('Tigger.deregisterTriggerListener: listener was not registered');
        }
    }
}
exports.Trigger = Trigger;
