import { AbstractProperty } from "../../properties/abstract-property";
import { SiblingAccess } from "./sibling-access";
export interface ListProvider<T extends AbstractProperty> extends SiblingAccess<T> {
    getList(): T[];
    clearList(): void;
    addProperty(atIndex?: number): T;
    getProperty(atIndex: number): T | undefined;
    removeByIndex(idx: number): T | undefined;
    moveProperty(from: number, to: number): void;
    isAsynchronous(): boolean;
    isProcessing(): boolean;
    shouldBeCached(): boolean;
    isReadOnly(): boolean;
}
