import { ListProvider } from "./list-provider";
import { PropertyId } from "../../properties/property-id";
import { PropertyTemplate } from "../../properties/factory/property-template";
import { AbstractDataProperty } from "../../properties/abstract-data-property";
export declare class SimpleListProvider<T extends AbstractDataProperty<D>, D> implements ListProvider<T> {
    private readonly id;
    private readonly propertyTemplate;
    private readonly getSelected;
    private readonly list;
    readonly siblingCount: number;
    private nxtId;
    constructor(id: PropertyId, propertyTemplate: PropertyTemplate<T, D>, getSelected: (idx: number) => boolean);
    getList(): T[];
    clearList(): void;
    addProperty(atIndex?: number): T;
    getProperty(atIndex: number): T | undefined;
    removeByIndex(idx: number): T | undefined;
    moveProperty(from: number, to: number): void;
    private adjustIndices;
    isAsynchronous(): boolean;
    isProcessing(): boolean;
    shouldBeCached(): boolean;
    isReadOnly(): boolean;
    getSibling(atIndex: number): T | undefined;
    someSibling(predicate: (sibling: T, index?: number) => unknown): boolean;
    everySibling(predicate: (sibling: T, index?: number) => unknown): boolean;
    reduceSiblings<R>(callbackfn: (previousValue: R, sibling: T, index?: number) => R, initialValue: R): R;
    filterSiblings(predicate: (sibling: T, index?: number) => unknown): T[];
}
