"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SelectValueProvider = void 0;
class SelectValueProvider {
    constructor(choicesSource, emptyChoice) {
        var _a;
        this.choicesSource = choicesSource;
        this.emptyChoice = emptyChoice;
        this.value = (_a = emptyChoice === null || emptyChoice === void 0 ? void 0 : emptyChoice.value) !== null && _a !== void 0 ? _a : null;
    }
    getValue() {
        return this.value;
    }
    setValue(value) {
        this.value = value;
    }
    getChoices() {
        const choices = this.choicesSource.getValue();
        if (this.emptyChoice) {
            return choices ? [this.emptyChoice, ...choices] : [this.emptyChoice];
        }
        return choices !== null && choices !== void 0 ? choices : [];
    }
    isAsynchronous() {
        return false;
    }
    isProcessing() {
        return this.choicesSource.isProcessing();
    }
    shouldBeCached() {
        return false;
    }
    isReadOnly() {
        return false;
    }
}
exports.SelectValueProvider = SelectValueProvider;
