"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertThat = exports.alwaysAssertThat = void 0;
const assertion_error_1 = require("./assertion-error");
function alwaysAssertThat(condition, text) {
    if (!condition) {
        throw new assertion_error_1.AssertionError(getMessage(text));
    }
}
exports.alwaysAssertThat = alwaysAssertThat;
function assertThat(condition, text) {
    let assertionFailed = false;
    try {
        assertionFailed = !condition();
    }
    catch (error) {
        console.error(error);
        throw new assertion_error_1.AssertionError(`Error while asserting with this message: ${getMessage(text)}`);
    }
    if (assertionFailed) {
        throw new assertion_error_1.AssertionError(getMessage(text));
    }
}
exports.assertThat = assertThat;
function getMessage(text) {
    let message;
    try {
        message = text();
    }
    catch (error) {
        console.log(error);
        message = 'Failed to build the assertion message';
    }
    return message;
}
