"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SelectValueConverter = void 0;
class SelectValueConverter {
    constructor(choices, emptyChoice) {
        this.emptyChoice = emptyChoice;
        this.choiceFcn = choices instanceof Function ? choices : () => choices;
    }
    fromDisplayValue(value) {
        var _a, _b;
        const choice = this.choiceFcn().find(c => c.displayValue === value);
        return (_a = choice === null || choice === void 0 ? void 0 : choice.value) !== null && _a !== void 0 ? _a : (value === ((_b = this.emptyChoice) === null || _b === void 0 ? void 0 : _b.displayValue) ? this.emptyChoice.value : null);
    }
    asDisplayValue(value) {
        var _a, _b, _c, _d;
        if (value == null) {
            return (_b = (_a = this.emptyChoice) === null || _a === void 0 ? void 0 : _a.displayValue) !== null && _b !== void 0 ? _b : '';
        }
        else {
            const choice = this.choiceFcn().find(c => c.value === value);
            return (_c = choice === null || choice === void 0 ? void 0 : choice.displayValue) !== null && _c !== void 0 ? _c : (value === ((_d = this.emptyChoice) === null || _d === void 0 ? void 0 : _d.value) ? this.emptyChoice.displayValue : '');
        }
    }
    getNullFallbackValue() {
        var _a, _b, _c;
        const fallback = (_b = (_a = this.emptyChoice) === null || _a === void 0 ? void 0 : _a.value) !== null && _b !== void 0 ? _b : (_c = this.choiceFcn()[0]) === null || _c === void 0 ? void 0 : _c.value;
        if (fallback) {
            return fallback;
        }
        else {
            throw new Error('No fallback available');
        }
    }
}
exports.SelectValueConverter = SelectValueConverter;
