import { SimpleListProvider } from "../../provider/list-provider/simple-list-provider";
export var SelectionMode;
(function (SelectionMode) {
    SelectionMode[SelectionMode["MultiSelect"] = 0] = "MultiSelect";
    SelectionMode[SelectionMode["SingleSelect"] = 1] = "SingleSelect";
})(SelectionMode || (SelectionMode = {}));
export class ListOfPropertiesBuilder {
    constructor(propertyList) {
        this.propertyList = propertyList;
    }
    create(id, itemTemplate, selectionMode) {
        const selectedIndices = [];
        const listProvider = new SimpleListProvider(id, itemTemplate, (idx) => selectedIndices.includes(idx));
        return this.propertyList(id, listProvider, selectedIndices, selectionMode === SelectionMode.MultiSelect);
    }
    template(id, factory) {
        return (prefix, index, siblingAccess) => factory(this, `${prefix}_${id}`, index, siblingAccess);
    }
    bindValidator(list, validator) {
        const instance = {
            getValidatedProperties: () => list.list,
            validate: validator
        };
        list.addValidator(instance);
    }
}
