import { AbstractProperty } from "./abstract-property";
import { GroupOfProperties } from "./group-of-properties";
import { ListOfProperties } from "./list-of-properties";
import { PropertyScalar } from "./property-scalar";
export declare type DataTypeAsProperty<D> = D extends (infer E)[] ? ListOfProperties<DataTypeAsProperty<E>, E> : D extends Record<string, unknown> ? GroupOfProperties<{
    [K in keyof D]: DataTypeAsProperty<D[K]>;
}, D> : D extends string | number | boolean | Date ? PropertyScalar<D> : AbstractDataProperty<D>;
export declare type DataTypeOfProperty<T> = T extends AbstractDataProperty<infer D> ? D : unknown;
export interface AbstractDataProperty<D> extends AbstractProperty {
    exportData(): D | null;
    importData(data: D | null): void;
    compareData(a: D | null, b: D | null): boolean;
}
