import { PropertyId } from "./property-id";
import { ValueChangeListener } from "./value-change-listener";
import { Trigger } from "./trigger";
import { BackpressureConfig } from "./backpressure/backpressure-config";
import { ValidationMessage } from "../validators/validation-message";
export interface AbstractProperty {
    readonly id: PropertyId;
    needsAnUpdate(notifyOthers?: boolean): void;
    registerValueChangedListener(changed: ValueChangeListener): void;
    deregisterValueChangedListener(changed: ValueChangeListener): void;
    setUpdateStrategy(strategy: 'Automatic' | 'Manually'): void;
    addUpdateTrigger(trigger: Trigger): void;
    addUpdateTrigger(trigger: Trigger, setUpdateStrategyManually: boolean): void;
    removeUpdateTrigger(trigger: Trigger): void;
    validate(): Promise<ValidationMessage[]>;
    isValid(): boolean;
    getValidationMessages(): ValidationMessage[];
    isAsynchronous(): boolean;
    backpressureConfig?: BackpressureConfig;
    isProcessing(): boolean;
    isReadOnly(): boolean;
}
