import { AbstractProperty } from "./abstract-property";
import { AbstractPropertyImpl } from "./abstract-property-impl";
import { GroupOfProperties } from "./group-of-properties";
import { RuleEngineUpdateHandler } from "../engine/rule-engine-update-handler-impl";
export declare class GroupOfPropertiesImpl<T extends {
    [id: string]: AbstractProperty;
}, D> extends AbstractPropertyImpl<D> implements GroupOfProperties<T, D> {
    readonly id: string;
    readonly properties: T;
    private readonly exportFcn;
    private readonly importFcn;
    readonly propertiesAsList: readonly AbstractProperty[];
    constructor(id: string, properties: T, exportFcn: (props: T) => D | null, importFcn: (props: T, data: D | null) => void, updateHandler: RuleEngineUpdateHandler);
    protected internallySyncUpdate(): void;
    protected internallyAsyncUpdate<V>(): {
        asyncPromise: Promise<V>;
        resolve: (value: V) => void;
    };
    protected getSpecialisedValidationResult(): never[];
    isValid(): boolean;
    isProcessing(): boolean;
    isReadOnly(): boolean;
    isAsynchronous(): boolean;
    exportData(): D | null;
    importData(data: D | null): void;
    compareData(a: D | null, b: D | null): boolean;
}
