import { AbstractPropertyImpl } from "./abstract-property-impl";
export class GroupOfPropertiesImpl extends AbstractPropertyImpl {
    constructor(id, properties, exportFcn, importFcn, updateHandler) {
        super(updateHandler);
        this.id = id;
        this.properties = properties;
        this.exportFcn = exportFcn;
        this.importFcn = importFcn;
        this.propertiesAsList = Object.keys(this.properties).map(propKey => this.properties[propKey]);
    }
    internallySyncUpdate() {
        throw new Error("Method not implemented.");
    }
    internallyAsyncUpdate() {
        throw new Error("Method not implemented.");
    }
    getSpecialisedValidationResult() {
        return [];
    }
    isValid() {
        return super.isValid() && Object.keys(this.properties).every(k => this.properties[k].isValid());
    }
    isProcessing() {
        return Object.keys(this.properties).some(k => this.properties[k].isProcessing());
    }
    isReadOnly() {
        return Object.keys(this.properties).every(k => this.properties[k].isReadOnly());
    }
    isAsynchronous() {
        return Object.keys(this.properties).some(k => this.properties[k].isAsynchronous());
    }
    exportData() {
        return this.exportFcn(this.properties);
    }
    importData(data) {
        this.importFcn(this.properties, data);
        this.needsAnUpdate();
    }
    compareData(a, b) {
        return true;
    }
}
