import { AbstractProperty } from "./abstract-property";
import { AbstractDataProperty } from "./abstract-data-property";
export interface ListOfProperties<T extends AbstractProperty, D> extends AbstractProperty, AbstractDataProperty<(D | null)[]> {
    readonly length: number;
    readonly list: T[];
    getProperty(index: number): T | undefined;
    addProperty(property?: T, atIndex?: number): T;
    addProperties(properties: number | T[], atIndex?: number): T[];
    addPropertyData(data: (D | null)[], atIndex?: number): T[];
    swapProperties(indexA: number, indexB: number): void;
    moveProperty(fromIndex: number, toIndex: number): void;
    removePropertyAtIndex(index: number): T | undefined;
    removeProperty(property: T): boolean;
    selectPropertyAtIndex(index: number): void;
    selectProperty(property: T): void;
    isPropertySelectedAtIndex(index: number): boolean;
    isPropertySelected(property: T): boolean;
    getSelectedIndices(): number[];
    getSelectedProperties(): {
        property: T;
        index: number;
    }[];
    unselectPropertyAtIndex(index: number): void;
    unselectProperty(property: T): void;
    unselectAll(): void;
}
