import { AttributeId } from "../attributes/attribute-id";
import { AbstractDataProperty } from "./abstract-data-property";
export interface PropertyScalar<D> extends AbstractDataProperty<D> {
    setToInitialValue(): void;
    getInitialValue(): D | null;
    getDisplayValue(): string;
    setDisplayValue(value: string | null): void;
    awaitDisplayValue(): Promise<string>;
    getNonNullValue(): D;
    getValue(): D | null;
    setValue(value: D | null): void;
    awaitValue(): Promise<D | null>;
    get<A>(id: AttributeId<A>): A | undefined;
    isRequired(): boolean;
    isVisible(): boolean;
    isEmpty(): boolean;
    getLabel(): string;
    getInfoText(): string;
    getPlaceholder(): string;
}
