import { Logger } from "../util/logger/logger";
export class Trigger {
    constructor(label) {
        this.label = label;
        this.listeners = [];
    }
    trigger() {
        return Promise.all(this.listeners.map(listener => listener.onTriggered())).then(() => {
            return;
        });
    }
    registerTriggerListener(listener) {
        if (!this.listeners.find(l => l === listener)) {
            this.listeners.push(listener);
        }
        else {
            Logger.debug('Tigger.registerTriggerListener: listener already registered');
        }
    }
    deregisterTriggerListener(listener) {
        const idx = this.listeners.findIndex(l => l === listener);
        if (idx >= 0) {
            this.listeners.splice(idx, 1);
        }
        else {
            Logger.debug('Tigger.deregisterTriggerListener: listener was not registered');
        }
    }
}
