import { Choice } from "../../../properties/choice";
import { PropertyScalar } from "../../../properties/property-scalar";
import { ValueProvider } from "../value-provider";
export declare class TypeaheadValueProvider<T> implements ValueProvider<[T | null, string]> {
    private readonly inputSource;
    private readonly choicesSource;
    constructor(inputSource: PropertyScalar<string>, choicesSource: PropertyScalar<Choice<T>[]>);
    getValue(): [T | null, string] | null;
    setValue(value: [T | null, string] | null): void;
    getChoices(): Choice<T>[];
    isAsynchronous(): boolean;
    isProcessing(): boolean;
    shouldBeCached(): boolean;
    isReadOnly(): boolean;
}
