export class TypeaheadValueProvider {
    constructor(inputSource, choicesSource) {
        this.inputSource = inputSource;
        this.choicesSource = choicesSource;
    }
    getValue() {
        const displayValue = this.inputSource.getNonNullValue();
        const choice = this.choicesSource.getNonNullValue().find(c => c.displayValue === displayValue);
        if (choice) {
            return [choice.value, displayValue];
        }
        return [null, displayValue];
    }
    setValue(value) {
        if (value != null) {
            if (value[0] != null) {
                const choice = this.choicesSource.getNonNullValue().find(c => c.value === value[0]);
                if (choice) {
                    value[1] = choice.displayValue;
                }
            }
            this.inputSource.setValue(value[1]);
        }
        else {
            this.inputSource.setValue('');
        }
    }
    getChoices() {
        return this.choicesSource.getNonNullValue();
    }
    isAsynchronous() {
        return false;
    }
    isProcessing() {
        return this.choicesSource.isProcessing();
    }
    shouldBeCached() {
        return false;
    }
    isReadOnly() {
        return false;
    }
}
