import { ValueProvider } from "./value-provider";
import { AbstractProperty } from "../../properties/abstract-property";
export declare class DerivedAsyncValueProvider<T, Dependencies extends readonly AbstractProperty[]> implements ValueProvider<T> {
    private readonly dependencies;
    private readonly get;
    private readonly set?;
    private processing;
    constructor(dependencies: Dependencies, get: (dependencies: Dependencies) => Promise<T | null>, set?: ((value: T | null, ...dependencies: Dependencies) => Promise<void>) | undefined);
    getValue(): Promise<T | null>;
    setValue(value: T | null): void;
    isAsynchronous(): boolean;
    isProcessing(): boolean;
    shouldBeCached(): boolean;
    isReadOnly(): boolean;
}
