export class DerivedValueProvider {
    constructor(dependencies, get, set) {
        this.dependencies = dependencies;
        this.get = get;
        this.set = set;
    }
    getValue() {
        return this.get(this.dependencies);
    }
    setValue(value) {
        if (this.set) {
            this.set(value, ...this.dependencies);
        }
    }
    isAsynchronous() {
        return false;
    }
    isProcessing() {
        return false;
    }
    shouldBeCached() {
        return true;
    }
    isReadOnly() {
        return !this.set;
    }
}
